diff -urN sourceold/scripts/gmvehicle.cpp source/scripts/gmvehicle.cpp
--- sourceold/scripts/gmvehicle.cpp	2019-06-22 07:43:44.233400000 +1000
+++ source/scripts/gmvehicle.cpp	2020-09-26 08:59:57.390149000 +1000
@@ -85,6 +85,12 @@
 				{
 					scr->IconModelID = 0;
 				}
+				if (!Is_Script_Attached(veh, "MS_AI_Marker_Vehicle_Search_Ignore"))
+				{
+					StringClass scriptParams;
+					scriptParams.Format("%d", Get_Object_Type(veh));
+					Commands->Attach_Script(veh, "MS_AI_Marker_Vehicle_Search_Ignore", scriptParams.Peek_Buffer());
+				}
 			}
 			else
 			{
@@ -131,6 +137,12 @@
 			{
 				Force_Occupant_Exit(boundveh, 0);
 			}
+			if (!Is_Script_Attached(boundveh, "MS_AI_Marker_Vehicle_Search_Ignore"))
+			{
+				StringClass scriptParams;
+				scriptParams.Format("%d", Get_Object_Type(boundveh));
+				Commands->Attach_Script(boundveh, "MS_AI_Marker_Vehicle_Search_Ignore", scriptParams.Peek_Buffer());
+			}
 		}
 		else
 		{
diff -urN sourceold/scripts/jfwcine.cpp source/scripts/jfwcine.cpp
--- sourceold/scripts/jfwcine.cpp	2018-11-17 10:23:57.197600000 +1000
+++ source/scripts/jfwcine.cpp	2020-09-10 09:08:27.963257800 +1000
@@ -845,7 +845,7 @@
 	{
 		Command_Add_Object(command);
 	}
-	else if (Title_Match(&command,"Create_Exploision"))
+	else if (Title_Match(&command,"Create_Explosion"))
 	{
 		Command_Create_Explosion(command);
 	}
@@ -1048,7 +1048,8 @@
 		GameObject *obj = Commands->Find_Object(Slots[slot]);
 		if (obj)
 		{
-			Commands->Set_Animation(obj,animation,loop,subobject,f2,-1,blended);
+			Update_Network_Object(obj);
+			Set_Subobject_Animation(obj,animation,loop,subobject,f2,-1,blended);
 			if (CameraControl)
 			{
 				Commands->Innate_Disable(obj);
diff -urN sourceold/scripts/jfwdef.cpp source/scripts/jfwdef.cpp
--- sourceold/scripts/jfwdef.cpp	2018-10-27 22:04:56.455400000 +1000
+++ source/scripts/jfwdef.cpp	2020-09-10 09:08:27.964255000 +1000
@@ -27,14 +27,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -105,14 +105,6 @@
 	}
 }
 
-void JFW_User_Controllable_Base_Defence::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_User_Controllable_Base_Defence::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -180,14 +172,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -236,14 +228,6 @@
 	}
 }
 
-void JFW_Base_Defence::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -307,14 +291,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -366,14 +350,6 @@
 	}
 }
 
-void JFW_Base_Defence_No_Aircraft::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_No_Aircraft::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -437,14 +413,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -496,14 +472,6 @@
 	}
 }
 
-void JFW_Base_Defence_Aircraft_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_Aircraft_Only::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -568,14 +536,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -632,14 +600,6 @@
 	}
 }
 
-void JFW_Base_Defence_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -705,14 +665,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -772,14 +732,6 @@
 	}
 }
 
-void JFW_Base_Defence_No_Aircraft_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_No_Aircraft_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -845,14 +797,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -912,14 +864,6 @@
 	}
 }
 
-void JFW_Base_Defence_Aircraft_Only_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_Aircraft_Only_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -1008,11 +952,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -1070,11 +1009,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_No_Aircraft::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_No_Aircraft::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -1132,11 +1066,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Aircraft_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Aircraft_Only::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -1200,11 +1129,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -1272,11 +1196,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_No_Aircraft_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_No_Aircraft_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -1344,11 +1263,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Aircraft_Only_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Aircraft_Only_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -1380,14 +1294,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -1439,14 +1353,6 @@
 	}
 }
 
-void JFW_Base_Defence_No_VTOL::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_No_VTOL::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -1548,14 +1454,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -1607,14 +1513,6 @@
 	}
 }
 
-void JFW_Base_Defence_VTOL_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_VTOL_Only::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -1679,14 +1577,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -1746,14 +1644,6 @@
 	}
 }
 
-void JFW_Base_Defence_No_VTOL_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_No_VTOL_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -1819,14 +1709,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -1886,14 +1776,6 @@
 	}
 }
 
-void JFW_Base_Defence_VTOL_Only_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_VTOL_Only_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -1985,11 +1867,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_No_VTOL::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_No_VTOL::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2047,11 +1924,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_VTOL_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_VTOL_Only::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2118,11 +1990,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_No_VTOL_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_No_VTOL_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2190,11 +2057,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_VTOL_Only_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_VTOL_Only_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2251,11 +2113,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2314,11 +2171,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_No_Aircraft::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_No_Aircraft::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2377,11 +2229,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_Aircraft_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_Aircraft_Only::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2446,11 +2293,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2519,11 +2361,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_No_Aircraft_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_No_Aircraft_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2592,11 +2429,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_Aircraft_Only_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_Aircraft_Only_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2656,11 +2488,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_No_VTOL::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_No_VTOL::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2719,11 +2546,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_VTOL_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_VTOL_Only::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2791,11 +2613,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_No_VTOL_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_No_VTOL_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2864,11 +2681,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_VTOL_Only_Secondary::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_VTOL_Only_Secondary::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -2901,14 +2713,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -2957,14 +2769,6 @@
 	}
 }
 
-void JFW_Base_Defence_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -3030,14 +2834,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -3088,14 +2892,6 @@
 	}
 }
 
-void JFW_Base_Defence_No_Aircraft_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_No_Aircraft_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -3161,14 +2957,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -3219,14 +3015,6 @@
 	}
 }
 
-void JFW_Base_Defence_Aircraft_Only_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_Aircraft_Only_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -3316,11 +3104,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -3380,11 +3163,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_No_Aircraft_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_No_Aircraft_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -3444,11 +3222,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Aircraft_Only_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Aircraft_Only_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -3481,14 +3254,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -3540,14 +3313,6 @@
 	}
 }
 
-void JFW_Base_Defence_No_VTOL_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_No_VTOL_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -3613,14 +3378,14 @@
 	Commands->Innate_Enable(obj);
 	Commands->Enable_Enemy_Seen(obj,true);
 	pos = Commands->Get_Position(obj);
-	pos1.X = pos.X - 10;
-	pos1.Y = pos.Y - 10;
+	pos1.X = pos.X - 5;
+	pos1.Y = pos.Y + 8.66025f;
 	pos1.Z = pos.Z + 2;
 	pos2.X = pos.X + 10;
 	pos2.Y = pos.Y;
 	pos2.Z = pos.Z + 2;
-	pos3.X = pos.X + 10;
-	pos3.Y = pos.Y - 10;
+	pos3.X = pos.X - 5;
+	pos3.Y = pos.Y - 8.66025f;
 	pos3.Z = pos.Z + 2;
 	object = Commands->Create_Object("Invisible_Object",pos1);
 	if (object)
@@ -3672,14 +3437,6 @@
 	}
 }
 
-void JFW_Base_Defence_VTOL_Only_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 2)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void JFW_Base_Defence_VTOL_Only_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	ActionParamsStruct var;
@@ -3772,11 +3529,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_No_VTOL_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_No_VTOL_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -3836,11 +3588,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_VTOL_Only_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_VTOL_Only_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -3898,11 +3645,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -3963,11 +3705,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_No_Aircraft_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_No_Aircraft_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -4028,11 +3765,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_Aircraft_Only_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_Aircraft_Only_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -4093,11 +3825,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_No_VTOL_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_No_VTOL_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -4158,11 +3885,6 @@
 	}
 }
 
-void JFW_Base_Defence_Animated_Sound_VTOL_Only_Swap::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void JFW_Base_Defence_Animated_Sound_VTOL_Only_Swap::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -4412,6 +4134,7 @@
 
 ScriptRegistrant<JFW_User_Controllable_Base_Defence> JFW_User_Controllable_Base_Defence_Registrant("JFW_User_Controllable_Base_Defence","MinAttackDistance=0.0:float,MaxAttackDistance=300.0:float,AttackTimer=10.0:float");
 ScriptRegistrant<JFW_Base_Defence> JFW_Base_Defence_Registrant("JFW_Base_Defence","MinAttackDistance=0.0:float,MaxAttackDistance=300.0:float,AttackTimer=10.0:float");
+ScriptRegistrant<JFW_Base_Defence> M00_Base_Defense_Registrant("M00_Base_Defense","MinAttackDistance=0:int,MaxAttackDistance=300:int,AttackTimer=10:int");
 ScriptRegistrant<JFW_Base_Defence_No_Aircraft> JFW_Base_Defence_No_Aircraft_Registrant("JFW_Base_Defence_No_Aircraft","MinAttackDistance=0.0:float,MaxAttackDistance=300.0:float,AttackTimer=10.0:float,Preset1:string,Preset2:string,Preset3:string,Preset4:string,Preset5:string,Preset6:string,Preset7:string,Preset8:string");
 ScriptRegistrant<JFW_Base_Defence_Aircraft_Only> JFW_Base_Defence_Aircraft_Only_Registrant("JFW_Base_Defence_Aircraft_Only","MinAttackDistance=0.0:float,MaxAttackDistance=300.0:float,AttackTimer=10.0:float,Preset1:string,Preset2:string,Preset3:string,Preset4:string,Preset5:string,Preset6:string,Preset7:string,Preset8:string");
 ScriptRegistrant<JFW_Base_Defence_Secondary> JFW_Base_Defence_Secondary_Registrant("JFW_Base_Defence_Secondary","MinAttackDistance=0.0:float,MaxAttackDistance=300.0:float,AttackTimer=10.0:float");
